\section{Assymetric Encryption and Hash Functions}

\subsection{Introduction to RSA}
The RSA cryptosystem was invented by Rivest, Shamir, Adelman. Its a public-key crypto system and widely used for secure data transmission. The keys (e, n) and (d) are reversible - either can be used for encryption, and the other used for decryption. There are two very useful cases for RSA. RSA allows us to use the same pair of keys for multiple connections instead using a key-pair for each connection. 

\begin{description}
	\item[1. Encryption only the owner of the public key can read] \hfill \\
	If i want to send data to a server that only the server should be able to read i can encrypt the data with the public key of the server. Even the sender can't decrypt the message he encrypted.
	\item[2. Signing that must have been performed by the owner of the private key] \hfill \\
	If i am a server wanting to identify myself i can sign the message with my private key and the receiver can verify this with the public key. 
\end{description}

\subsubsection{Encryption using RSA}
For efficiency on a computer, $e$ is a small number (usually 2 or 3). $n$ is a very large semi prime number, meaning $n$ is $2$ large prime numbers multiplied together.

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{rsa}
  \caption{RSA Overview}
\end{figure}

\begin{description}
	\item[Prima factorisation] \hfill \\
	The euclid show that every number hash exactly one prime factorisation. Factoring a large prime number is nearly impossible. (time complexity). $n=30 \; = 5*3*2$ or $n=589 \; = 19*31$
	\item[One-way trapdoor function] \hfill \\
	There is no way to undo the encryption function unless you know the trapdoor. Knowing the factors of n is the trapdoor.
	\item[Euler PHI function $\phi(n)$] \hfill \\
	Outputs how many integers are lass than or equal to n that do not share any common factor with n (Teilerfremd). $\phi(8)=4$ or $\phi(7)=6$
	\item[Euler theorem] \hfill \\
	The PHI can be calculated easily when $m (message)$ is a relative prime to $n (public key)$\\
\begin{center}
$m^{\phi(n)}=1 \; mod \; n$ \\
$m=5,n=8$, $5^{\phi(8)}=1 \; mod \; 8$, $5^{4} = 625$
\end{center}
\end{description} 

\subsubsection{Digital Signing using RSA}
Digital signature is often sent as a challenge. We want the server to provide its identity. The server encrypts its message with his private key and then the client can decrypt the message with the public key. The construct (challenge-response) is a core part of Transport layer security (TLS).

\subsubsection{DSA}
Can't be used for encryption. Only works one way, therefore for signing.

\subsection{The Hash Function}
Is used to verify if the send data got changed in transit to the destination. Takes a message on any length, and returns a pseudorandom hash of fixed length. A 128 bit hash function will return a 128 bit string, regardless of how much bits have been hashed in. Hash functions are used everywhere. Strong Hash functions have five important priorities. The current standard is SHA-2 256 bits and 512 bits. SHA-3 is designed to be used when the SHA-2 function is broken. The SHA-X are not good to use as a password hash, they are too fast.

\begin{description}
	\item[1. It has to be quick but not too quick] \hfill
	\item[2. It has to introduce diffusion] \hfill 
	\item[3. Given a hash, we can't reverse it]\hfill 
	\item[4. We can't find any two message that have the same hash]\hfill 
	\item[5. Given a message and its hash, we can't find another message that hashes to the same thing]\hfill 
\end{description}

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{hashes}
  \caption{Different Hash Algorithmes}
\end{figure}

\subsubsection{Where are Hashes used?}
They are used for digital signature and symmetric cryptography is vulnerable to message tampering, they can ad integrity. A Hashing lets us ensure that a message hasn't been altered. 

\textbf{Example:} Alice knows the shared key. She will append the key to the ciphertext and will hash the ciphertext with the key and get h(K | C). She sends the ciphertext with $hash(Key | Cypertext)$ to Bob. Bob will append the key to the ciphertext and will hash the ciphertext with the key and calculate h(K | C). If h(K|C) is the same than that the one sent by Alice, the ciphertext has not been modified. 


\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{digitalsigning}
  \caption{Digital Signing}
\end{figure}

\subsubsection{Calculating a Hash}

\begin{minipage}{0.5\linewidth}
Usually hash functions iretaively jumble blocks of a message after another. This is a one-way function. There is no way to revert back and restore the initial message. A change in one bit must diffuse through the entire output (avalanche effect).
\end{minipage}
\begin{minipage}{0,5\linewidth}
	\center
	\includegraphics[width=\linewidth]{hashfunction}
\end{minipage}

\subsubsection{Hash Collision}
A hash collision occurs if different inputs lead to the same hash value of the file. This means the encryption standard is broken and shouldn't be used anymore.
